/* Copyright (C) 2005  Jean-Franois Geyelin */

// C Source File
// Created 7/29/2005; 1:43:05 AM

#include <tigcclib.h>
#include "all.h"



void increase_score(PLAYER_STRUCT * p, short delta) {
	p->score_till_new_life+=delta;
	p->score+=delta;
	if (p->score_till_new_life>POINT_NEEDED_FOR_A_NEW_LIFE) {
		p->score_till_new_life-=POINT_NEEDED_FOR_A_NEW_LIFE;
		p->lives++;
		//exit(0);
	}
}

#define FILE_SIZE 25

void read_scores(SCORE_STRUCT *s) {
	SYM_ENTRY *sym = SymFindPtr(SYMSTR("m4r10sco"),0);

	char *ptrFILE;
	if (!sym) {
		HANDLE handle;		
		handle=HeapAlloc(FILE_SIZE);
		if(!handle) return;
		sym=DerefSym(SymAdd(SYMSTR("m4r10sco")));
		if(!sym) {HeapFree(handle); return;}
		sym->handle=handle;
		ptrFILE=HeapDeref(handle);
		*(short*)ptrFILE=FILE_SIZE-2;
		ptrFILE[FILE_SIZE-6]=0;
		strcpy(ptrFILE+FILE_SIZE-5,"HSC");
		ptrFILE[FILE_SIZE-1]=OTH_TAG;
	}
	
	
	ptrFILE=HeapDeref(sym->handle);
	memcpy(s,ptrFILE+2,sizeof(SCORE_STRUCT));
	
	if (s->magic!=MAGIC_NUM) {
		s->magic = MAGIC_NUM;
		s->score = 0;
		s->level = 0;
		memcpy(ptrFILE+2,s,sizeof(SCORE_STRUCT));
	}
}



void update_score(unsigned long score, short level) {
	SCORE_STRUCT s;
	read_scores(&s);
	if (s.score < score)
	s.score = score;
	if (s.level < level)
	s.level = level;
	SYM_ENTRY *sym = SymFindPtr(SYMSTR("m4r10sco"),0);
	char * ptrFILE=HeapDeref(sym->handle);
	memcpy(ptrFILE+2,&s,sizeof(SCORE_STRUCT));
}


